--- Portal

local function SonicModelExists()
    if SonicSD and file.Exists("models/weapons/c_sonicsd.mdl", "GAME") then
        return true
    end
    return false
end

local T = {}

T.Versions = {
    randomize = false,
    allow_custom = true,
    randomize_custom = false,

    main = {
        id = "portal",
    },
}

T.EnableClassicDoors = true

T.Base = "base"
T.Name = "Test Chamber 2"
T.ID = "portal"
T.Interior = {
    Model = "models/FuzzyLeo/PortalTARDIS/Main.mdl",
    IdleSound = {
        {
            path = "ambient/atmosphere/ambience_base.wav",
            volume = 0.5
        },
    },
    Light = {
        color = Color(147, 200, 224),
        warncolor = Color(255, 60, 60),
        pos = Vector(-356.494, 103.065, 266.184),
        brightness = 2,
    },
    Lights = {
        {
            color = Color(147, 200, 224),
            warncolor = Color(255, 60, 60),
            pos = Vector(-179.712, -132.16, 241.822),
            brightness = 0.8,
            nopower = false
        },
        {
            color = Color(147, 200, 224),
            warncolor = Color(255, 60, 60),
            pos = Vector(179.712, -132.16, 241.822),
            brightness = 1,
            nopower = false
        },
    },
    Lamps = {
        observationlamp1 = {
            color = Color(147, 200, 224),
            texture = "effects/flashlight/soft",
            fov = 56,
            distance = 1281.6511230469,
            brightness = 1.2517091035843,
            pos = Vector(53.9658203125, 593.8671875, 278.68359375),
            ang = Angle(18.948699951172, -84.653503417969, 0),
            shadows = true,
            warn = {
                -- same list of options available
                sprite_brightness = 0.5,
                color = Color(255, 60, 60),
            },
        },
        observationlamp2 = {
            color = Color(147, 200, 224),
            texture = "effects/flashlight/soft",
            fov = 43,
            distance = 1281.6511230469,
            brightness = 1.2517091035843,
            pos = Vector(-309.4951171875, 494.1298828125, 440.431640625),
            ang = Angle(15.448603630066, -92.532386779785, 0),
            shadows = true,
            warn = {
                -- same list of options available
                sprite_brightness = 0.5,
                color = Color(255, 60, 60),
            },
        },
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(0, 412.75, 78.9),
        ang = Angle(-0, -90, 0),
        width = 85,
        height = 127,
        inverted = 0,
    },
    Fallback = {
        pos = Vector(0, 400, 23),
        ang = Angle(0, 0, 0)

    },
    Screens = {
        {
            pos = Vector(22.666, 3.935, 97.5),
            ang = Angle(0, 135, 65),
            width = 410,
            height = 375,
            gui_rows = 4,
            power_off_black = true
        }
    },
    Scanners = {
        {
            mat = "models/fuzzyleo/portaltardis/lab_monitor_screen",
            width = 1024,
            height = 1024,
            ang = Angle(0,0,0),
            fov = 90,
        }
    },
    ExitDistance = 1000,
    Sounds = {
        Teleport = { },
        Cloister = "ambient/alarms/combine_bank_alarm_loop4.wav",
    },
    Sequences = "portal_sequence",
    Parts = {
        intdoor = { model="models/FuzzyLeo/PortalTARDIS/door.mdl", },
		door={
			posoffset=Vector(0, 0, 0),
		},
        portal_main2            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_mainprops            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_stairstuff            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_glass            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_rotor            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_console            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_portalgun            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_monitors            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_radio            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_controlmisc            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_keyboards            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_button            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        portal_doortogglehitbox            =   {pos = Vector(43.4, 0, 67.2),                     ang = Angle(0, 0, 0),               },
        portal_demathitbox            =   {pos = Vector(30.787, 0, 81.455),                     ang = Angle(0, 0, 0),               },
        portal_flighthitbox            =   {pos = Vector(38.792, -9.924, 66.683),  ang = Angle(0, 45, 0),               },
        portal_physlock            =   {pos = Vector(38.792, 9.924, 66.683),  ang = Angle(0, 45, 0),               },
        portal_screenstogglehitbox            =   {pos = Vector(35.589, 26.234, 68.139),                     ang = Angle(0, 0, 0),               },
        portal_scannertogglehitbox            =   {pos = Vector(-36.415, -25.805, 67.773),                     ang = Angle(0, 0, 0),               },
        portal_doorlockhitbox            =   {pos = Vector(7.605, 45.17, 68.654),                     ang = Angle(0, 0, 0),               },
        portal_enginereleasehitbox            =   {pos = Vector(36.317, -24.549, 67.231),                     ang = Angle(0, 0, 0),               },
        portal_powerhitbox            =   {pos = Vector(25.395, -36.522, 67.38),                     ang = Angle(0, 0, 0),               },
        portal_manualdestselect            =   {pos = Vector(-20.666, 20.787, 74.566),                     ang = Angle(0, 0, 0),               },
        portal_hadshitbox            =   {pos = Vector(-5.218, 45.011, 68.072),                     ang = Angle(0, 0, 0),               },
        portal_coordshitbox            =   {pos = Vector(-26.41, 36.016, 68.167),                     ang = Angle(0, 0, 0),               },
        portal_repairhitbox            =   {pos = Vector(-26.621, -36.709, 67.872),                     ang = Angle(0, 0, 0),               },
        portal_redecorate            =   {pos = Vector(-34.763, 27.107, 69.041),                     ang = Angle(0, 0, 0),               },
        portal_handbrake            =   {pos = Vector(26.737, 35.823, 68.137),                     ang = Angle(0, 0, 0),               },
        portal_radiohitbox            =   {pos = Vector(0, -40.151, 77.393),                     ang = Angle(0, 0, 0),               },
        portal_fastreturn            =   {pos = Vector(5.73, 32.637, 71.356),                     ang = Angle(0, 0, 0),               },
        portal_isomorphic            =   {pos = Vector(-5.73, 32.637, 71.356),                     ang = Angle(0, 0, 0),               },
        portal_cloak            =   {pos = Vector(0, 23.412, 76.18),                     ang = Angle(0, 0, 0),               },
        portal_float            =   {pos = Vector(-45.318, 0, 68.683),                     ang = Angle(0, 0, 0),               },
        portal_sonicdispenser            =   {pos = Vector(20.752, -20.931, 87.219),                     ang = Angle(0, 0, 0),               },
        portal_manualflight            =   {pos = Vector(-35.392, 0, 71.385),                     ang = Angle(0, 0, 0),               },
    },
    IntDoorAnimationTime = 0,
    Controls = {
        portal_doortogglehitbox          = "door",
        portal_demathitbox            = "teleport_double",
        portal_flighthitbox         = "flight",
        default_screen              = nil,
        portal_screenstogglehitbox        = "toggle_screens",
        portal_scannertogglehitbox       = "toggle_scanners",
        portal_doorlockhitbox         = "doorlock",
        portal_enginereleasehitbox       = "engine_release",
        portal_powerhitbox          = "power",
        portal_manualdestselect            = "destination",
        portal_hadshitbox                = "hads",
        portal_coordshitbox          = "coordinates",
        portal_repairhitbox         = "repair",
        portal_redecorate    = "redecorate",
        portal_handbrake           = "handbrake",
        portal_radiohitbox          = "music",
        portal_fastreturn            = "fastreturn",
        portal_physlock            = "physlock",
        portal_isomorphic          = "isomorphic",
        portal_float               = "float",
        portal_cloak         = "cloak",
        default_dematcircuit        = nil,
        portal_sonicdispenser      = "sonic_dispenser",
        default_sonic_inserted      = SonicModelExists() and "sonic_dispenser",
        portal_manualflight              = "thirdperson",
        default_atomaccel           = "spin_toggle",
        default_directionalpointer  = "spin_switch",

    },
    Tips = {},
    -- Interior.Tips are deprecated; should be deleted when the extensions update and
    -- replace with Interior.CustomTips, Interior.PartTips and Interior.TipSettings
    TipSettings = {
        view_range_min = 70,
        view_range_max = 90,
    },
    CustomTips = {
        --{ text = "Example", pos = Vector(0, 0, 0) },
    },
    PartTips = {

        portal_doortogglehitbox            =   {pos = Vector(43.4, 0, 67.2), down = true},
        portal_demathitbox            =   {pos = Vector(30.787, 0, 81.455), down = true},
        portal_flighthitbox            =   {pos = Vector(43.527, -10.054, 68.051), down = true},
        portal_physlock            =   {pos = Vector(43.527, 10.054, 68.051), down = true},
        portal_screenstogglehitbox            =   {pos = Vector(35.589, 26.234, 68.139), down = true},
        portal_scannertogglehitbox            =   {pos = Vector(-36.415, -25.805, 67.773), down = true},
        portal_doorlockhitbox            =   {pos = Vector(7.605, 45.17, 68.654), down = true},
        portal_enginereleasehitbox            =   {pos = Vector(36.317, -24.549, 67.231), down = true},
        portal_powerhitbox            =   {pos = Vector(25.395, -36.522, 67.38), down = true},
        portal_manualdestselect            =   {pos = Vector(-20.666, 20.787, 74.566), down = true},
        portal_hadshitbox            =   {pos = Vector(-5.218, 45.011, 68.072), down = true},
        portal_coordshitbox            =   {pos = Vector(-26.41, 36.016, 68.167), down = true},
        portal_repairhitbox            =   {pos = Vector(-26.621, -36.709, 67.872), down = true},
        portal_redecorate            =   {pos = Vector(-34.763, 27.107, 69.041), down = true},
        portal_handbrake            =   {pos = Vector(26.737, 35.823, 68.137), down = true},
        portal_radiohitbox            =   {pos = Vector(0, -40.151, 77.393), down = true},
        portal_fastreturn            =   {pos = Vector(5.73, 32.637, 71.356), down = true},
        portal_isomorphic            =   {pos = Vector(-5.73, 32.637, 71.356), down = true},
        portal_cloak            =   {pos = Vector(0, 23.412, 76.18), down = true},
        portal_float            =   {pos = Vector(-45.318, 0, 68.683), down = true},
        portal_sonicdispenser            =   {pos = Vector(20.752, -20.931, 87.219), down = true},
        portal_manualflight            =   {pos = Vector(-35.392, 0, 71.385), down = true},
    },
    LightOverride = {
        basebrightness = 0.1 ,
        nopowerbrightness = 0.0025
    },
    Seats = {
        {
            pos = Vector(130, -96, -30),
            ang = Angle(0, 40, 0)
        },
        {
            pos = Vector(125, 55, -30),
            ang = Angle(0, 135, 0)
        }
    },
    BreakdownEffectPos = Vector(114, 215, 40),
}

T.Exterior = {
    Model="models/FuzzyLeo/PortalTARDIS/Exterior.mdl",
    DoorAnimationTime = 0,
    Parts = {
        door = {
            Model="models/FuzzyLeo/PortalTARDIS/Exteriordoor.mdl",
            posoffset=Vector(6.2, 1, -59)
        },
        vortex = {
            pos = Vector(0,0,50),
            ang = Angle(0,0,0),
            scale =10
        },
    },
    Fallback = {
        pos = Vector(15,0,1),
        ang = Angle(0,0,0)
    },
    Sounds = {
        Teleport = {
            demat = "ambient/levels/citadel/portal_beam_shoot6.wav",
            mat = "FuzzyLeo/portaltardis/portalland.wav",
            mat_fast = "ambient/machines/teleport3.wav",
            mat_damaged_fast = "p00gie/tardis/mat_damaged_fast.wav",
            fullflight = "ambient/machines/teleport3.wav",
            interrupt = "drmatt/tardis/repairfinish.wav",
        },
        Spawn = "FuzzyLeo/portaltardis/portal_elevator_chime.wav",
        RepairFinish = "FuzzyLeo/portaltardis/portal_elevator_chime.wav",
        Delete = "FuzzyLeo/portaltardis/portal_fizzle2.wav",
        Door={
			enabled=true,
			open="FuzzyLeo/portaltardis/portal_open1.wav",
			close="FuzzyLeo/portaltardis/portal_close1.wav",
            locked = "ambient/levels/labs/electric_explosion5.wav"
		},
        FlightLoop = "ambience/mechwhine.wav",
        FlightLoopDamaged = "drmatt/tardis/flight_loop_damaged.wav",
    },
    ProjectedLight = {
        --color = Color(r,g,b), --Base color. Will use main interior light if not set.
        --warncolor = Color(r,g,b), --Warning color. Will use main interior warn color if not set.
        brightness = 0.1, --Light's brightness
        vertfov = 80,
        horizfov = 50, --vertical and horizontal field of view of the light. Will default to portal height and width.
        farz = 750, --FarZ property of the light. Determines how far the light projects.]]
        offset = Vector(-16.5, 0, 40), --Offset from box origin
        texture = "effects/flashlight/square" --Texture the projected light will use. You can get these from the Lamp tool.
    },
    Light={
        enabled=false,
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(-6.2, -1, 59),
        ang = Angle(0, 0, 0),
        width = 80,
        height = 114,
        thickness = 54,
    },
    Teleport = {
        SequenceSpeed = 20,
        SequenceSpeedWarning = 1,
        SequenceSpeedFast = 20,
        SequenceSpeedWarnFast = 10,
        DematSequence = {
            200,
            100,
            150,
            0
        },
        DematSequenceDelays={
            [1] = 0
        },
        MatSequence = {
            50,
            100,
            50,
            255
        },
        MatSequenceDelays={
            [2] = 0
        },
    },
}

T.CustomSettings = {
    interior_lighting = {
        text = "Interior Lighting",
        value_type = "list",
        value = "bright",
        options = {
            ["bright"] = "Bright",
            ["dark"] = "Dark",
        }
    },
}



local function playerlookingat(self,ply,vec,fov,width)
    local disp = vec - self:WorldToLocal(ply:GetPos()+Vector(0,0,64))
    local dist = disp:Length()

    local maxcos = math.abs( math.cos( math.acos( dist / math.sqrt( dist * dist + width * width ) ) + fov * ( math.pi / 180 ) ) )
    disp:Normalize()

    if disp:Dot( ply:EyeAngles():Forward() ) > maxcos then
        return true
    end

    return false
end

T.Interior.CustomHooks = {
    init_rotor = {
        "Initialize",
        function(self)
            self.timerotor={}
            self.timerotor.pos=0
            self.timerotor.mode=1
        end
    },
    think_rotor = {
        "Think",
        function(self)
            local moving = self.exterior:GetData("teleport",false)
            local flightmode = self.exterior:GetData("flight",false)
            local active = (moving or flightmode)
            if not CLIENT then return end
            if active or self.timerotor.pos > 0 then
                if self.timerotor.pos==1 then
                    self.timerotor.mode=0
                elseif active and self.timerotor.pos==0 then
                    self.timerotor.mode=1
                end
                self.timerotor.pos=math.Approach( self.timerotor.pos, self.timerotor.mode, FrameTime()*1.1 )
                self:SetPoseParameter( "glass", self.timerotor.pos )
            end
        end,
    },
    use_console = {
        "Use",
        function(self,a,c)
            if SERVER and a:IsPlayer() and (not a:GetTardisData("outside")) and CurTime() > a:GetTardisData("outsidecool",0) then
                local pos=Vector(0,0,0)
                local pos2=self:WorldToLocal(a:GetPos())
                local distance=pos:Distance(pos2)
                if distance < 110 and playerlookingat(self,a,pos,10,10) then
                    TARDIS:Control("thirdperson_careful", a)
                end
            end
        end,
    },
}

local function is_selected_exterior(id, ply, ent, this_setting)
	if TARDIS:GetInterior(id).EnableClassicDoors ~= true then
		return false
	end

	local setting = TARDIS:GetCustomSetting(id, "exterior", ply)

	if setting ~= "random" then
		return (setting == this_setting)
	end

	local data = ent:GetData("hellbent_selected_exterior")
	if data ~= nil then
		return (this_setting == data)
	end
end


TARDIS:AddInterior(T)
